# SoBoxHighlightRenderAction Class Reference
[Actions]

`#include <Inventor/actions/SoBoxHighlightRenderAction.h>`

Inheritance diagram for SoBoxHighlightRenderAction:

List of all members.

## Detailed Description

The SoBoxHighlightRenderAction class renders the scene with highlighted boxes around selections.

This action performs the same tasks as its parent class, SoGLRenderAction, with the added ability to render highlighted bounding boxes around geometry in selected nodes. This is a simple but convenient way of giving feedback to the user upon interaction with the scene graph.

To have the highlighting actually happen (and to be able to automatically "select" nodes by picking with the mouse cursor), you need to use SoSelection nodes in place of group nodes.

See also:
  SoLineHighlightRenderAction, SoSelection

## Public Member Functions

| SoBoxHighlightRenderAction (void)
| SoBoxHighlightRenderAction (const SbViewportRegion &viewportregion)
virtual | ~SoBoxHighlightRenderAction ()
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void | setVisible (const SbBool visible)
SbBool | isVisible (void) const
void | setColor (const SbColor &color)
const SbColor & | getColor (void)
void | setLinePattern (unsigned short pattern)
unsigned short | getLinePattern (void) const
void | setLineWidth (const float width)
float | getLineWidth (void) const

## Static Public Member Functions

void | initClass (void)

## Protected Attributes

SbBool | hlVisible

## Constructor & Destructor Documentation

SoBoxHighlightRenderAction::SoBoxHighlightRenderAction | ( | void |  | ) |

| Default constructor. Note: passes a default SbViewportRegion to the parent constructor.

SoBoxHighlightRenderAction::SoBoxHighlightRenderAction | ( | const SbViewportRegion & | viewportregion | ) |

| Constructor, taking an explicit viewportregion to render.

SoBoxHighlightRenderAction::~SoBoxHighlightRenderAction | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

void SoBoxHighlightRenderAction::initClass | ( | void |  | ) | `[static]`

| Initializes the run-time type system for this class, and sets up the enabled elements and action method list. Reimplemented from SoGLRenderAction.

void SoBoxHighlightRenderAction::apply | ( | SoNode * | node | ) | `[virtual]`

| Applies the action to the scene graph rooted at root. Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined. Reimplemented from SoAction.

void SoBoxHighlightRenderAction::apply | ( | SoPath * | path | ) | `[virtual]`

| Applies the action to the parts of the graph defined by path. If the path ends in an SoGroup node, the action will also traverse the tail node's children. Reimplemented from SoAction.

void SoBoxHighlightRenderAction::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE
| ) | `[virtual]`

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

Reimplemented from SoAction.

void SoBoxHighlightRenderAction::setVisible | ( | const SbBool | visible | ) |

| Sets if highlighted boxes should be visible when rendering. Defaults to `TRUE`.

SbBool SoBoxHighlightRenderAction::isVisible | ( | void |  | ) | const

| Return if highlighted boxes are to be visible.

void SoBoxHighlightRenderAction::setColor | ( | const SbColor & | color | ) |

| Sets the color for the highlighted boxes. Defaults to completely red.

const SbColor & SoBoxHighlightRenderAction::getColor | ( | void |  | ) |

| Returns rendering color of the highlighted boxes.

void SoBoxHighlightRenderAction::setLinePattern | ( | unsigned short | pattern | ) |

| Sets the line pattern used for the highlighted boxes. Defaults to `0xffff` (i.e. drawn with no stipples).

unsigned short SoBoxHighlightRenderAction::getLinePattern | ( | void |  | ) | const

| Returns line pattern used when drawing boxes.

void SoBoxHighlightRenderAction::setLineWidth | ( | const float | width | ) |

| Sets the line width used when drawing boxes, in screen pixels (as for all OpenGL rendering). Defaults to 3.

float SoBoxHighlightRenderAction::getLineWidth | ( | void |  | ) | const

| Returns the line width used when drawing highlight boxes.

## Member Data Documentation

SoBoxHighlightRenderAction::hlVisible`[protected]`

| Boolean which decides whether or not the highlights for selected nodes should be visible.

The documentation for this class was generated from the following files:

- SoBoxHighlightRenderAction.h
- SoBoxHighlightRenderAction.cpp